global function fft

array <vector> function fft(array<vector> input)
{
		int N = input.len();
		array <vector> output
		if(N == 1){
			output = input;
			return output;
		}
		array <vector> leftSide
		array <vector> rightSide
		for (int g = 0; g<N/2;g++){
			if(g*2<N)
				leftSide.append(input[g*2])
		}
		leftSide = fft(leftSide)
		
		for (int g = 0; g<N/2;g++){
			if(g*2+1<N)
				rightSide.append(input[g*2+1])
		}
		rightSide = fft(rightSide)
		
		int k = 0;
		
		foreach(vec in rightSide)
		{
			leftSide.append(vec)
		}
		output = leftSide
		
		while (k<=N/2-1){
			vector u = output[k];
			vector t = <cos(-2*k*PI/N)*output[k+N/2].x - sin(-2*k*PI/N)*output[k+N/2].y,cos(-2*k*PI/N)*output[k+N/2].y+sin(-2*k*PI/N)*output[k+N/2].x,0>; //fix here, multiplying works differently
			output[k] = u + t;
			output[k+N/2] = u - t;
			k = k + 1;
		}
		
		return output;
}
